#if __IPHONE_OS_VERSION_MAX_ALLOWED >= 170000 && __IPHONE_OS_VERSION_MAX_ALLOWED < 180000

#import "Xcode_15_0_XCTestCore_CDStructures.h"
#import "Xcode_15_0_SharedHeader.h"
#import "Xcode_15_0_XCTActivityRecordContext.h"
#import <Foundation/Foundation.h>
#import <XCTest/XCTContext.h>

@protocol XCTContextDelegate;

@class XCTActivityRecordStack, XCTContext, XCTestCase;

//
//     Generated by class-dump 3.5 (64 bit).
//
//     class-dump is Copyright (C) 1997-1998, 2000-2001, 2004-2013 by Steve Nygard.
//

@interface XCTContext ()
{
    _Bool _valid;
    _Bool _isReportingBase;
    NSDate *_startDate;
    NSMutableDictionary *_associatedObjects;
    NSMutableArray *_tearDownBlocks;
    XCTContext *_parent;
    XCTestCase *_testCase;
    id <XCTContextDelegate> _delegate;
    XCTActivityRecordStack *_activityRecordStack;
}

+ (_Bool)hasCurrentContext;
+ (id)currentContextIfAvailable;
+ (void)_runInChildOfContext:(id)arg1 forTestCase:(id)arg2 markAsReportingBase:(_Bool)arg3 block:(CDUnknownBlockType)arg4;
+ (void)runInContextForTestCase:(id)arg1 markAsReportingBase:(_Bool)arg2 block:(CDUnknownBlockType)arg3;
+ (void)runInContextForTestCase:(id)arg1 block:(CDUnknownBlockType)arg2;
+ (_Bool)shouldReportActivityWithType:(id)arg1 inTestMode:(long long)arg2;
+ (_Bool)_shouldReportActivityWithType:(id)arg1;
+ (void)_recordActivityMessageWithFormat:(id)arg1;
+ (void)_runActivityNamed:(id)arg1 block:(CDUnknownBlockType)arg2;
+ (void)runInternalActivityNamed:(id)arg1 block:(CDUnknownBlockType)arg2;
+ (void)_runActivityNamed:(id)arg1 type:(id)arg2 block:(CDUnknownBlockType)arg3;

+ (id)currentContext;
@property(readonly) XCTActivityRecordStack *activityRecordStack; // @synthesize activityRecordStack=_activityRecordStack;
@property(readonly) _Bool isReportingBase; // @synthesize isReportingBase=_isReportingBase;
@property __weak id <XCTContextDelegate> delegate; // @synthesize delegate=_delegate;
@property(readonly) __weak XCTestCase *testCase; // @synthesize testCase=_testCase;
@property(readonly) XCTContext *parent; // @synthesize parent=_parent;
@property(readonly, getter=isValid) _Bool valid; // @synthesize valid=_valid;
@property(readonly) NSMutableArray *tearDownBlocks; // @synthesize tearDownBlocks=_tearDownBlocks;
@property(readonly) NSMutableDictionary *associatedObjects; // @synthesize associatedObjects=_associatedObjects;
@property(readonly, copy) NSDate *startDate; // @synthesize startDate=_startDate;
- (void)addTearDownBlock:(CDUnknownBlockType)arg1;
- (void)setAssociatedObject:(id)arg1 forKey:(id)arg2;
- (id)associatedObjectForKey:(id)arg1;
@property(readonly) NSDictionary *aggregationRecords;
- (id)topActivity;
- (void)runInContextForTestCase:(id)arg1 markAsReportingBase:(_Bool)arg2 block:(CDUnknownBlockType)arg3;
- (void)runInContextForTestCase:(id)arg1 block:(CDUnknownBlockType)arg2;
@property(readonly) unsigned long long activityRecordStackDepth;
- (void)unwindRemainingActivities;
- (void)_reportEmptyActivityWithType:(id)arg1 format:(id)arg2;
- (void)_runActivityNamed:(id)arg1 type:(id)arg2 block:(CDUnknownBlockType)arg3;
- (void)didFinishActivity:(id)arg1;
- (id)willStartActivityWithTitle:(id)arg1 type:(id)arg2;
- (id)observationCenter;
- (id)associatedContexts;
- (_Bool)isBoundToCurrentThread;
@property(readonly) unsigned long long transitiveActivityRecordStackDepth;
@property(readonly) XCTContext *reportingBaseContext;
- (id)initWithParent:(id)arg1 testCase:(id)arg2;
- (void)invalidate;
- (void)_recordActivityMessageWithFormat:(id)arg1;
- (void)_runActivityNamed:(id)arg1 block:(CDUnknownBlockType)arg2;
- (void)runInternalActivityNamed:(id)arg1 block:(CDUnknownBlockType)arg2;
@property(readonly) NSDictionary *testRunConfiguration;

// Remaining properties

@end

#endif