#if __IPHONE_OS_VERSION_MAX_ALLOWED >= 170000 && __IPHONE_OS_VERSION_MAX_ALLOWED < 180000

#import "Xcode_15_0_XCUIAutomation_CDStructures.h"
#import "Xcode_15_0_SharedHeader.h"
#import "Xcode_15_0_XCTElementSnapshotAttributeDataSource.h"
#import "Xcode_15_0_XCUIIssueDiagnosticsProviding.h"
#import <Foundation/Foundation.h>

@protocol XCTRunnerAutomationSession, XCUIApplicationProcessDelegate, XCUIDevice;

@class XCAccessibilityElement, XCElementSnapshot, XCTFuture;

//
//     Generated by class-dump 3.5 (64 bit).
//
//     class-dump is Copyright (C) 1997-1998, 2000-2001, 2004-2013 by Steve Nygard.
//

@interface XCUIApplicationProcess : NSObject <XCTElementSnapshotAttributeDataSource, XCUIIssueDiagnosticsProviding>
{
    NSObject *_queue;
    _Bool _accessibilityActive;
    unsigned long long _applicationState;
    int _processID;
    id _token;
    int _exitCode;
    _Bool _eventLoopHasIdled;
    _Bool _animationsHaveFinished;
    _Bool _hasExitCode;
    _Bool _hasCrashReport;
    _Bool _mayTerminateOutOfBandWithoutCrashReport;
    unsigned long long _alertCount;
    id <XCTRunnerAutomationSession> _automationSession;
    XCTFuture *_automationSessionFuture;
    NSString *_path;
    NSString *_bundleID;
    XCElementSnapshot *_lastSnapshot;
    id <XCUIDevice> _device;
    id <XCUIApplicationProcessDelegate> _delegate;
}

+ (id)keyPathsForValuesAffectingIsQuiescent;
+ (_Bool)automaticallyNotifiesObserversForKey:(id)arg1;
+ (id)keyPathsForValuesAffectingIsProcessIDValid;
+ (id)keyPathsForValuesAffectingForeground;
+ (id)keyPathsForValuesAffectingBackground;
+ (id)keyPathsForValuesAffectingSuspended;
+ (id)keyPathsForValuesAffectingRunning;
+ (id)keyPathsForValuesAffectingIsApplicationStateKnown;
@property(readonly) id <XCUIApplicationProcessDelegate> delegate; // @synthesize delegate=_delegate;
@property(readonly) id <XCUIDevice> device; // @synthesize device=_device;
@property(retain) XCElementSnapshot *lastSnapshot; // @synthesize lastSnapshot=_lastSnapshot;
@property(nonatomic) _Bool mayTerminateOutOfBandWithoutCrashReport; // @synthesize mayTerminateOutOfBandWithoutCrashReport=_mayTerminateOutOfBandWithoutCrashReport;
@property _Bool hasCrashReport; // @synthesize hasCrashReport=_hasCrashReport;
@property _Bool hasExitCode; // @synthesize hasExitCode=_hasExitCode;
@property(readonly, copy, nonatomic) NSString *bundleID; // @synthesize bundleID=_bundleID;
@property(readonly, copy, nonatomic) NSString *path; // @synthesize path=_path;
- (id)diagnosticAttachmentsForError:(id)arg1;
- (_Bool)isMacCatalystForPID:(int)arg1;
@property(readonly) _Bool hasBannerNotificationIsStickyAttribute;
@property(readonly) _Bool usePointTransformationsForFrameConversions;
@property(readonly) _Bool supportsHostedViewCoordinateTransformations;
- (id)parameterizedAttribute:(id)arg1 forElement:(id)arg2 parameter:(id)arg3 error:(id *)arg4;
- (id)valuesForPrivilegedAttributes:(id)arg1 forElement:(id)arg2 error:(id *)arg3;
@property(readonly) _Bool providesValuesForPrivilegedAttributes;
- (id)attributesForElement:(id)arg1 attributes:(id)arg2 error:(id *)arg3;
@property(readonly) _Bool allowsRemoteAccess;
- (id)_underlyingDataSourceForElement:(id)arg1;
- (_Bool)terminate:(id *)arg1;
- (_Bool)waitForViewControllerViewDidDisappearWithTimeout:(double)arg1 error:(id *)arg2;
- (void)acquireBackgroundAssertion;
@property(readonly) XCTFuture *automationSessionFuture; // @synthesize automationSessionFuture=_automationSessionFuture;
- (id)_queue_automationSessionFuture;
- (void)waitForAutomationSession;
@property(readonly) id <XCTRunnerAutomationSession> automationSessionNonBlocking;
@property(retain, nonatomic) id <XCTRunnerAutomationSession> automationSession; // @synthesize automationSession=_automationSession;
- (_Bool)isQuiescent;
- (void)_initiateQuiescenceChecksIncludingAnimationsIdle:(_Bool)arg1;
- (void)waitForQuiescenceIncludingAnimationsIdle:(_Bool)arg1;
- (id)_makeQuiescenceExpectation;
- (void)_notifyWhenAnimationsAreIdle:(CDUnknownBlockType)arg1;
- (_Bool)_supportsAnimationsIdleNotifications;
- (void)_notifyWhenMainRunLoopIsIdle:(CDUnknownBlockType)arg1;
- (void)resetAlertCount;
- (void)incrementAlertCount;
@property(readonly) unsigned long long alertCount; // @synthesize alertCount=_alertCount;
@property _Bool animationsHaveFinished;
@property _Bool eventLoopHasIdled;
@property int exitCode;
@property(retain) id token;
@property(nonatomic) int processID;
@property(readonly, getter=isProcessIDValid) _Bool processIDValid;
@property(readonly) _Bool foreground;
@property(readonly) _Bool background;
@property(readonly) _Bool suspended;
@property(readonly) _Bool running;
- (_Bool)isApplicationStateKnown;
- (void)_awaitKnownApplicationState;
@property(nonatomic) unsigned long long applicationState;
@property(nonatomic) _Bool accessibilityActive;
@property(readonly, copy) XCAccessibilityElement *accessibilityElement;
@property(readonly, copy) NSString *shortDescription;
- (id)_queue_description;
- (id)initWithBundleID:(id)arg1 device:(id)arg2 delegate:(id)arg3;
- (id)initWithPath:(id)arg1 bundleID:(id)arg2 device:(id)arg3 delegate:(id)arg4;

// Remaining properties

@end

#endif